package com.fossgalaxy.games.tbs.metrics.parameters;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.fossgalaxy.games.tbs.parameters.GameSettings;

import io.jenetics.Gene;
import io.jenetics.Genotype;
import io.jenetics.IntegerGene;

public class ParameterList implements Iterable<Parameter> {
	private List<Parameter> parameters;
	
	public ParameterList() {
		this.parameters = new ArrayList<>();
	}
	
	public GameSettings apply(GameSettings common, Genotype<IntegerGene> values) {
	
		GameSettings instance = new GameSettings(common);
		
		for (int i=0; i<values.geneCount(); i++) {
			Parameter p = parameters.get(i);
			
			p.update(instance, values.get(i).getGene().intValue());
		}
		
		return instance;
	}

	public void add(Parameter entityCost) {
		parameters.add(entityCost);
	}

	@Override
	public Iterator<Parameter> iterator() {
		return parameters.iterator();
	}

}
